<?php if (!defined('PmWiki')) exit();
/**
 * set_menu_file.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2005-2023
 * @note This file is part of Cookbook recipe "Jscm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package jscm
 */

## Set Default / Group and Page menus
  // **********************************************************
  SDV($Jscm['default']['MenuFilePath'], "uploads/Jscm/"); #not implemented
  SDV($Jscm['default']['MenuFileExt'], ".jscm"); #not implemented
  SDV($Jscm['default']['MenuFile'], $Jscm['Current']['dir'].'/js/defaultmenu.js');

  $Jscm['menu']['PageNameFmt']['Site'] =
      $Jscm['default']['MenuPageGroup'] . '.' .
      $Jscm['default']['MenuPageName'];
  $Jscm['menu']['PageNameFmt']['Group'] =
      $Jscm['page']['CurrentGroup'] . '.' .
      $Jscm['default']['MenuPageName'];
  $Jscm['menu']['PageNameFmt']['Page'] =
      $Jscm['page']['CurrentGroup'] . '.' .
      $Jscm['page']['CurrentName'] .
      $Jscm['default']['MenuPageName'];
  $Jscm['menu']['PageNameFmt']['Default'] =
      $Jscm['default']['MenuFile']; // '.' string check
  // **********************************************************

## set menu page  #not implemented
  // *******************************************************
  ## default
  $Jscm['menu']['TxtUrlFmt']['Default'] =
      @jscm_get_cmfile_url_fmt($Jscm['menu']['PageNameFmt']['Default']);
  $Jscm['menu']['content'] = @$Jscm['menu']['TextFmt']['Default'];
  ## site
  $Jscm['menu']['PageUrlFmt']['Site'] =
      'jscm_get_cmpage_url_fmt($Jscm["menu"]["PageNameFmt"]["Site"])';
  ## group
  $Jscm['menu']['PageUrlFmt']['Group'] =
      'jscm_get_cmpage_url_fmt($Jscm["menu"]["PageNameFmt"]["Group"])';
  ## page
  $Jscm['menu']['PageUrlFmt']['Page'] =
      'jscm_get_cmpage_url_fmt($Jscm["menu"]["PageNameFmt"]["Page"])';
  ## default
  $Jscm['menu']['PageUrlFmt']['Default'] =
      'jscm_get_cmfile_url_fmt($Jscm["menu"]["PageNameFmt"]["Default"])';

  // **********************************************************

// *******************************************************
$cmPage = array();
//$InbuiltCM = "$thisScriptDUrl/js/defaultmenu.js";
$InbuiltCM = $Jscm['Install']['dirUrl']."/js/defaultmenu.js";

## #########
## Site
$cmPage['site'] = $Jscm['menu']['PageNameFmt']['Site'];
## Group
if ($cmPage['site'] != $Jscm['menu']['PageNameFmt']['Group']) {
  $cmPage['group'] = $Jscm['menu']['PageNameFmt']['Group'];
}
## Page
$cmPage['page'] = $Jscm['menu']['PageNameFmt']['Page'];
#Menus defined in last page/file takes precedence.
## #########

$cmSource = array();
$cmDefaultActionFmt = "?action=source";
foreach ($cmPage as $k => $v) {
  $cmSource[$k] = jscm_set_cm_source($v,$cmDefaultActionFmt); #this takes precedence.
  if ( ! isset($cmSource[$k])) $cmSource[$k] = jscm_set_cm_file($v);
}

## debug
global $EnableJscmDebug;
if($EnableJscmDebug > 0) {
  //$Jscm['debug']['msg']['cmPage'] = $cmPage;
  //$Jscm['debug']['msg']['cmSource'] = $cmSource;
}

SDV($LocalCM, 'local/localcookmenu.js');
global $ScriptUrl;
if (file_exists($LocalCM)) {
  $LocalCMPage = dirname($ScriptUrl)."/$LocalCM";
  $cmFile['local'] = "<script type='text/javascript' src='$LocalCMPage'></script>";
  array_unshift($cmSource, $cmFile['local']);
}

$cmSources = array();
# Set the final array for menu sources.
foreach ($cmSource as $k => $v) {
  if (@trim($v)) $cmSources[$k] = $v;
}
if (count($cmSources) == '0') {
  $cmSources['inbuilt'] = "<script type='text/javascript' src='$InbuiltCM'></script>";
}

// *******************************************************

$HTMLHeaderFmt['jscmMenu'] = "\n<!--jscm menu-->\n".
implode("\n", $cmSources) .
"\n<!--/jscm menu-->";

// *******************************************************




